# Exemplos simples REST

## Cliente REST à API do [Chuck Norris](https://rapidapi.com/matchilling/api/chuck-norris) da [RapidAPI.com](https://rapidapi.com)

- Para executar
```
stack build
stack exec chuck
```
- Não esqueça de criar um arquivo `rapidapi.key` no diretório raiz
      com a sua chave de acesso. Para obter uma visite [RapidAPI.com](https://rapidapi.com)

## Exemplo de cliente e servidor REST

A aplicação de exemplo é uma aplicação boba que calcula um caminho
entre duas palavras. Por exemplo, para transformar um coelho em um
tomate basta fazer: `COELHO -> COELHA -> COLHA -> COLA -> COMA -> TOMA -> TOMAR -> TOMARA -> TOMARAS -> TOMARES -> TOMATES -> TOMATE`

Para testar o servidor:

```
stack build
stack exec word-server
```
e acesse a URL http://localhost:3000/path/coelho/tomate do seu browser, por exemplo. Veja a lista completa de endpoints no arquivo `WordServer.hs`

Para testar o cliente, rode o servidor e em seguida:

```
stack exec word-client
```

## Caveat Emptor

Note que este código não trata diversos casos de erro possíveis em
uma aplicação real. Note também que a implementação está
deliberadamente incompleta (por exemplo alguns endpoints estão
como `undefined` para servir placeholders para imlplementações de
alunos do curso de Haskell na Universidade Federal do ABC.

Todos os arquivos são licenciados por CC-BY-SA.
Este material pode ser usado livremente desde que sejam mantidos,
além deste aviso, os créditos aos autores e instituições.

Emilio Francesquini <e.francesquini@ufabc.edu.br>

CC-BY-SA - 09/2019
